$! Script to tailor "JTmakspc.com" script to makspc.com per site needs.
$set noverify
$! Copyright (c) 1994 Glenn C. Everhart
$! All Rights Reserved
$ask:==inquire
$emit:==write sys$output
$fsr=f$search("gcy$sys:JTmakspc.com")
$if fsr .eqs. ""
$ then
$ emit "%GCE - F - Cannot find template make-space script"
$ exit
$ endif
$set command sys$system:zmenu
$write sys$output "[H[J"
$write sys$output "[0;33;44m"
$ write sys$output -
"M<>[?4l[?8h[m",-
"(B)07[?6l[r8#6"
$!
$minspc=100
$minage=7
$medspc=1000
$bigshlv=250000
$minwb=3600
$sslist=""
$smptr=1
$domenu:
$zmenu/POINTER="[1;7m-->[m"/SYMBOLS/initial='f$string(smptr)'
      Site Space Policy Determination

     ^ Set min size file to migrate when space is needed (now 'minspc')
     ^ Set min age in days for files to be moved (now 'minage')
     ^ Set largest "medium sized" file size (now 'medspc')
     ^ Set largest file size eligible for shelving (now 'bigshlv')
     ^ Specify substrings of file patJT to leave alone
     ^ Clear substring list (now "'sslist'")
     ^ Report space occupied by files which would be selected
     ^ Run the space-making script to free max space
     ^ Set time-in-wastebasket min. for files to be cleaned up ('minwb')
     ^ Done this menu, build the selection script
     ^ Quit the menu, doing nothing
$!
$ if choice .eq. 11 then exit
$ if choice .eq. 9
$ then
$ emit "When making space, the first action is to finally remove"
$ emit "files deleted more than  N seconds ago. Here we select the"
$ emit "value of N. If N is 0 or negative, we do not do this purging"
$ emit "action here."
$ ask xinwb "Give time (in sec.) since file deletion to leave file on disk:"
$ if xinwb .eqs. "" then xinwb="3600"
$ minwb = 'xinwb'
$ goto domenu
$ endif
$ smptr = choice
$ if choice .eq. 1
$ then
$ emit "File sizes selected are, First: files between min and max medium"
$ emit "sized file; Second: files bigger than max medium size file;"
$ emit "Third: files smaller than min sized file but over 10 blks"
$ ask msz "Give min. file size to move, blocks [must be 10 or more]"
$ if msz .eqs. "" then goto domenu
$ mnsz=f$integer(msz)
$ if mnsz .lt. 10 then goto domenu
$ minspc = mnsz
$ goto domenu
$ endif
$ if choice .eq. 2
$ then
$ emit "If the minimum age to move is over 9999, we don't shelve files at all."
$ ask mag "Minimum age file to move (days)"
$ if mag .eqs. "" then goto domenu
$ mnag=f$integer(mag)
$ if mag .lt. 2 then goto domenu
$ minage = mnag
$ goto domenu
$ endif
$ if choice .eq. 3
$ then
$ emit "File sizes selected are, First: files between min and max medium"
$ emit "sized file; Second: files bigger than max medium size file;"
$ emit "Third: files smaller than min sized file but over 10 blks"
$ ask mddd "Largest size of `medium` files (blocks)"
$ if mddd .eqs. "" then goto domenu
$ mndd=f$integer(mddd)
$ if mndd .lt. 11 then goto domenu
$ medspc = mndd
$ goto domenu
$ endif
$ if choice .eq. 4
$ then
$ emit "File sizes selected are, First: files between min and max medium"
$ emit "sized file; Second: files bigger than max medium size file;"
$ emit "Third: files smaller than min sized file but over 10 blks"
$ ask mddd "Largest size of `large` files (blocks)"
$ if mddd .eqs. "" then goto domenu
$ mndd=f$integer(mddd)
$ if mndd .lt. (medspc+2) then goto domenu
$ bigshlv = mndd
$ goto domenu
$ endif
$ if choice .eq. 5
$ then
$ emit "Give a string to be protected, with normal wildcards"
$ emit "or several strings separated by commas."
$ ask fsg "String"
$ if fsg .eqs. "" then goto domenu
$ if sslist .nes. "" then sslist = sslist + "," + fsg
$ if sslist .eqs. "" then sslist = fsg
$ goto domenu
$ endif
$ if choice .eq. 6
$ then
$ sslist = ""
$ goto domenu
$ endif
$ if choice .eq. 7
$ then
$ open/read mtp gcy$sys:JTrptspc.com
$ open/write mksf gcy$sys:rptspc.tmp
$! find the +++$$$=== marker
$x5rdl1:
$ read/end=x5doend mtp fline
$ lnln=f$length(fline)
$ if f$locate("+++$$$",fline) .lt. lnln then goto x5rde1
$ write mksf fline
$ goto x5rdl1
$x5rde1:
$! insert minal and dayago variables
$ write mksf fline
$ write mksf "$dayago = ",f$string(minage)
$ write mksf "$minal = ",f$string(minspc)
$ write mksf "$medal = ",f$string(medspc)
$ write mksf "$secondsago = ",f$string(minwb)
$! now get to second marker which is +++@@@===
$x5rdl2:
$ read/end=x5doend mtp fline
$ lnln=f$length(fline)
$ if f$locate("+++@@@",fline) .lt. lnln then goto x5rde2
$ write mksf fline
$ goto x5rdl2
$x5rde2:
$ write mksf fline
$! Now insert any filespec skip instructions.
$! line is of form
$! $if f$locate("VMS$CO",vlin) .lt. f$length(vlin) then goto editloop
$if sslist .eqs. "" then goto x5rdl3
$elnum=0
$! Get all file pathname parts and insert the desired cuts on them.
$x5ellop:
$npart=f$element(elnum,",",sslist)
$if npart .eqs. "" then goto x5rdl3
$elnum=elnum+1
$elst="$if f$locate(""" + npart + """,vlin) .lt. f$length(vlin) then goto editloop"
$write mksf elst
$goto x5ellop
$x5rdl3:
$! copy the rest of the template
$ read/end=x5doend mtp fline
$ write mksf fline
$ goto x5rdl3
$x5doend:
$close mtp
$close mksf
$nndvc = " "
$ask nndvc "What device do you want a report on?"
$xnndvc = nndvc - ":"
$xnndvc="*"+xnndvc+"*"
$if nndvc .eqs. "" .or. f$device(xnndvc) .eqs. "" then goto domenu
$emit "Script built. Executing..."
$ getfree = f$getdvi(nndvc,"maxblock")
$ getfree = getfree / 10
$ if getfree .lt. 100 then getfree = 100
$@gcy$sys:rptspc.tmp 'nndvc' 'f$string(getfree)'
$wait 0:0:10
$set noverify
$goto domenu
$ endif
$if choice .eq. 8
$ then
$ fline=" "
$ open/read mtp gcy$sys:JTmakspc.com
$ open/write mksf gcy$sys:makspc.com
$! find the +++$$$=== marker
$x6rdl1:
$ read/end=x6doend mtp fline
$ lnln=f$length(fline)
$ if f$locate("+++$$$",fline) .lt. lnln then goto x6rde1
$ write mksf fline
$ goto x6rdl1
$x6rde1:
$! insert minal and dayago variables
$ write mksf fline
$ write mksf "$dayago = ",f$string(minage)
$ write mksf "$minal = ",f$string(minspc)
$ write mksf "$medal = ",f$string(medspc)
$! now get to second marker which is +++@@@===
$x6rdl2:
$ read/end=x6doend mtp fline
$ lnln=f$length(fline)
$ if f$locate("+++@@@",fline) .lt. lnln then goto x6rde2
$ write mksf fline
$ goto x6rdl2
$x6rde2:
$ write mksf fline
$! Now insert any filespec skip instructions.
$! line is of form
$! $if f$locate("VMS$CO",vlin) .lt. f$length(vlin) then goto editloop
$if sslist .eqs. "" then goto x6rdl3
$elnum=0
$! Get all file pathname parts and insert the desired cuts on them.
$x6ellop:
$npart=f$element(elnum,",",sslist)
$if npart .eqs. "" then goto x6rdl3
$elnum=elnum+1
$elst="$if f$locate(""" + npart + """,vlin) .lt. f$length(vlin) then goto editloop"
$write mksf elst
$goto x6ellop
$x6rdl3:
$! copy the rest of the template
$ read/end=x6doend mtp fline
$ write mksf fline
$ goto x6rdl3
$x6doend:
$close mtp
$close mksf
$set noon
$copy gcy$sys:makspc.com gcy$cm:makspc.com
$set on
$ask nndvc "What device do you want free space found on?"
$if nndvc .eqs. "" .or. f$search(nndvc) .eqs. "" then goto domenu
$emit "Script built. Executing..."
$ getfree = f$getdvi(nndvc,"maxblock")
$ getfree = getfree / 10
$ if getfree .lt. 100 then getfree = 100
$@gcy$sys:makspc.com 'nndvc' 'f$string(getfree)'
$ goto domenu
$ endif
$ if choice .eq. 10
$ then
$! done setup, go edit the file.
$ goto doedit
$ endif
$doedit:
$ fline=" "
$ open/read mtp gcy$sys:JTmakspc.com
$ open/write mksf gcy$sys:makspc.com
$! find the +++$$$=== marker
$rdl1:
$ read/end=doend mtp fline
$ lnln=f$length(fline)
$ if f$locate("+++$$$",fline) .lt. lnln then goto rde1
$ write mksf fline
$ goto rdl1
$rde1:
$! insert minal and dayago variables
$ write mksf fline
$ write mksf "$dayago = ",f$string(minage)
$ write mksf "$minal = ",f$string(minspc)
$ write mksf "$medal = ",f$string(medspc)
$ write mksf "$maxswp = ",f$string(bigshlv)
$ write mksf "$secondsago = ",f$string(minwb)
$! now get to second marker which is +++@@@===
$rdl2:
$ read/end=doend mtp fline
$ lnln=f$length(fline)
$ if f$locate("+++@@@",fline) .lt. lnln then goto rde2
$ write mksf fline
$ goto rdl2
$rde2:
$ write mksf fline
$! Now insert any filespec skip instructions.
$! line is of form
$! $if f$locate("VMS$CO",vlin) .lt. f$length(vlin) then goto editloop
$if sslist .eqs. "" then goto rdl3
$elnum=0
$! Get all file pathname parts and insert the desired cuts on them.
$ellop:
$npart=f$element(elnum,",",sslist)
$if npart .eqs. "" then goto rdl3
$elnum=elnum+1
$elst="$if f$locate(""" + npart + """,vlin) .lt. f$length(vlin) then goto editloop"
$write mksf elst
$goto ellop
$rdl3:
$! copy the rest of the template
$ read/end=doend mtp fline
$ write mksf fline
$ goto rdl3
$doend:
$close mtp
$close mksf
$set noon
$copy gcy$sys:makspc.com gcy$cm:makspc.com
$set on
$exit
