!mms file to build JT material
! Copyright (c) 1994 Glenn C. Everhart
! All Rights Reserved
!
cc	=	cc
macro	=	macro
cflags	=	/object=$(mms$target)
mflags	=	/object=$(mms$target)
fortran	=	fortran
fflags	=	/object=$(mms$target)/nocheck
!
!-----------------------------------------------------------------------------
!  General rules for creating targets from sources
!
.cld.obj :
    set command/object=$(mms$target) $(mms$source)

.cxx.obj :
    $(cxx)$(cxxflags) $(mms$source)

.MAR.MLB :
	IF F$SEARCH(F$PARSE("$(MMS$TARGET)")) .NES. F$SEARCH("$(MMS$TARGET)") -
		THEN COPY/LOG $(MMS$TARGET) $(MMS$TARGET)
	IF F$SEARCH(F$PARSE("$(MMS$TARGET)")) .EQS. "" -
		THEN $(LIBR)/CREATE/MACRO/LOG $(MMS$TARGET)
	$(LIBR) $(LIBRFLAGS) $(MMS$TARGET) $(MMS$SOURCE)
	COPY/REPLACE _NL: $(MMS$TARGET)-TIME-STAMP.1

.mar.obj :
    $(macro)/obj=$(mms$target) $(mflags) $(mms$source)

.mar.dbg :
    $(macro) $(mflags) /debug $(mms$source)

.for.obj :
    $(fortran)/nocheck/obj=$(mms$target) $(fflags) $(mms$source)

.for.dbg :
    $(fortran) $(fflags) /debug/noopt $(mms$source)

.c.obj :
    $(cc)/obj=$(mms$target) $(cflags) $(mms$source)

.MSG.SDL :
	$(sdl)$(msgsdlflags) $(mms$source)

.OBJ.OLB :
	IF F$SEARCH(F$PARSE("$(MMS$TARGET)")) .NES. F$SEARCH("$(MMS$TARGET)") -
		THEN COPY/LOG $(MMS$TARGET) $(MMS$TARGET)
	IF F$SEARCH(F$PARSE("$(MMS$TARGET)")) .EQS. "" -
		THEN $(LIBR)/CREATE/LOG $(MMS$TARGET)
	$(LIBR) $(LIBRFLAGS) $(MMS$TARGET) $(MMS$SOURCE)
	COPY/REPLACE _NL: $(MMS$TARGET)-TIME-STAMP.1

.suffixes
.suffixes .exe .olb .obj .c .cld .cxx .mlb .mar .for .h .sdi .sdl .com -
		.dcl .msg
!
!-----------------------------------------------------------------------------
!  Specific rules for building targets
!
all : obj$:jtauthm.obj,obj$:jtdriver.obj,obj$:jtdmn.obj,-
      obj$:jtmodace.obj,obj$:jttrnlnm.obj,obj$:jtopn.obj,-
      obj$:jtoprmsg.obj,obj$:jtrplace.obj,obj$:jtauthmaint.obj,-
      obj$:jtdolog.obj,obj$:jtlic.obj,exe$:jtdolog.exe,obj$:jtdeldo.obj,-
      obj$:jtspawn.obj,obj$:jtsubprc1.obj,obj$:jtsubprc2.obj,-
      obj$:jtsubprc3.obj
      link/exe=exe$:jtdriver.exe/notrace obj$:jtdriver+-
      obj$:jtsawn+jtsubprc1+jtsubprc2+jtsubprc3+sys$system:sys.stb/sel+-
      src$:jtdriver.opt/opt
      link/exe=exe$:jtdmn.exe obj$:jtdmn+jtlic+jtopn+jtdeldo+jtoprmsg+jttrnlnm+sys$system:sys.stb/sel
      link/exe=exe$:jtauthmaint jtauthmaint+jtmodace+jtauthm+jtoprmsg
      write sys$output "done"

obj$:jtauthm.obj :	src$:jtauthm.mar

obj$:jtdriver.obj :	src$:jtdriver.mar

obj$:jtdmn.obj :	src$:jtdmn.mar

obj$:jtmodace.obj :	src$:jtmodace.mar

obj$:jttrnlnm.obj :	src$:jttrnlnm.mar

obj$:jtopn.obj :	src$:jtopn.for

obj$:jtoprmsg.obj :	src$:jtoprmsg.for

obj$:jtrplace.obj :	src$:jtrplace.for

obj$:jtauthmaint.obj :	src$:jtauthmaint.for

obj$:jtdolog.obj :	src$:jtdolog.for

obj$:jtlic.obj :	src$:jtlic.mar

obj$:jtdeldo.obj :	src$:jtdeldo.for

obj$:jtspawn.obj :	src$:jtspawn.for

obj$:jtsubprc1.obj :	src$:jtsubprc1.mar

obj$:jtsubprc2.obj :	src$:jtsubprc2.mar

obj$:jtsubprc3.obj :	src$:jtsubprc3.mar
